/*
 * Copyright (c) 2020-2040, 北京符节科技有限公司 (support@fujieid.com & https://www.fujieid.com).
 * <p>
 * Licensed under the GNU LESSER GENERAL PUBLIC LICENSE 3.0;
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * <p>
 * http://www.gnu.org/licenses/lgpl.html
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Authorization service based on RFC6749 protocol specification and OpenID Connect Core 1.0 specification
 * <p>
 * Features：
 * <p>
 * 1. Authorization Code Grant
 * <p>
 * 2. Implicit Grant
 * <p>
 * 3. Resource Owner Password Credentials Grant
 * <p>
 * 4. Refresh Token
 * <p>
 * 5. Check Token
 * <p>
 * 6. Proof Key for Code Exchange by OAuth Public Clients
 * <p>
 * 7. OpenID Connect Discovery
 * <p>
 * 8. OpenID Connect Front-Channel Logout
 * <p>
 * 9. OpenID Connect Back-Channel Logout
 * <p>
 * 10. ...
 *
 * @author yadong.zhang (yadong.zhang0415(a)gmail.com)
 * @version 1.0.0
 * @see <a href="https://tools.ietf.org/html/rfc6749" target="_blank"> The OAuth 2.0 Authorization Framework</a>
 * @see <a href="https://openid.net/specs/openid-connect-core-1_0.html" target="_blank">OpenID Connect Core 1.0 incorporating errata set 1</a>
 * @see <a href="https://tools.ietf.org/html/rfc7636" target="_blank">Proof Key for Code Exchange by OAuth Public Clients</a>
 * @see <a href="https://tools.ietf.org/html/rfc7033" target="_blank">WebFinger</a>
 * @see <a href="https://openid.net/specs/openid-connect-discovery-1_0.html" target="_blank">OpenID Connect Discovery 1.0 incorporating errata set 1</a>
 * @see <a href="https://openid.net/specs/openid-connect-frontchannel-1_0.html" target="_blank">OpenID Connect Front-Channel Logout 1.0</a>
 * @see <a href="https://openid.net/specs/openid-connect-backchannel-1_0.html" target="_blank">OpenID Connect Back-Channel Logout 1.0</a>
 * @since 1.0.0
 */
package com.fujieid.jap.ids;
